# Copyright (c) 1999-2003 Xerox Corporation.  All Rights Reserved.
#
# Permission to use, copy, modify  and  distribute  without  charge
# this  software,  documentation, images, etc. is granted, provided
# that this copyright and the author's name is retained.
#    
# A fee may be charged for this program ONLY to recover  costs  for
# distribution  (i.e.  media costs).  No profit can be made on this
# program.
#        
# The author assumes no responsibility for  disasters  (natural  or
# otherwise) as a consequence of use of this software.
#            
# Adam Stein (adam\@scan.mc.xerox.com)

# Set up the commands in this frame
sub ShowFrame4 {
  my ($cgi) = shift,                            # CGI object
  my ($view) = shift,                           # Calendar view
  my ($date) = shift,                           # Date to offset from
  my ($aurl),					# URL for adding appointment
  my ($label),					# Label to use for links
  my (@last),					# Last date
  my (@next),					# Next date
  my ($nurl),                                   # URL for next date
  my ($purl),                                   # URL for previous date
  my (@today),					# Today's date
  my ($turl),					# URL for today's date
  my ($url),                                    # URL to use for links
  my (@view),					# Links for different views
  my ($vurl);					# URL for view links

  # Set up common part of URL
  $url = $cgi->url . "?key=" . $cgi->param("key");

  # Change a few things depending on view
  SWITCH: {
    # Day View
    if ($view == V_DAY) {
      $label = "Day";

      # Figure out last and next dates for URL links
      @last = Add_Delta_Days(@$date, -1);
      @next = Add_Delta_Days(@$date, 1);

      # Different view links
      $view[0] = "Day View";

      $vurl = "$url&day=$$date[2]&month=$$date[1]&year=$$date[0]&view=" . V_WEEK;
      $view[1] = $cgi->a({href => "javascript:update(4, '$vurl', 5)"},
			 "Week View");

      $vurl = "$url&day=$$date[2]&month=$$date[1]&year=$$date[0]&view=" . V_MONTH;
      $view[2] = $cgi->a({href => "javascript:update(4, '$vurl', 5)"},
			 "Month View");
      
      $vurl = "$url&day=$$date[2]&month=$$date[1]&year=$$date[0]&view=" . V_YEAR;
      $view[3] = $cgi->a({href => "javascript:update(4, '$vurl', 5)"},
			 "Year View");

      last;
    }

    # Week View
    if ($view == V_WEEK) {
      $label = "Week";

      # Figure out last and next dates for URL links
      @last = Add_Delta_Days(@$date, -7);
      @next = Add_Delta_Days(@$date, 7);

      # Different view links
      $vurl = "$url&day=$$date[2]&month=$$date[1]&year=$$date[0]&view=" . V_DAY;
      $view[0] = $cgi->a({href => "javascript:update(4, '$vurl', 5)"},
			 "Day View");

      $view[1] = "Week View";

      $vurl = "$url&day=$$date[2]&month=$$date[1]&year=$$date[0]&view=" . V_MONTH;
      $view[2] = $cgi->a({href => "javascript:update(4, '$vurl', 5)"},
			 "Month View");

      $vurl = "$url&day=$$date[2]&month=$$date[1]&year=$$date[0]&view=" . V_YEAR;
      $view[3] = $cgi->a({href => "javascript:update(4, '$vurl', 5)"},
			 "Year View");

      last;
    }

    # Month View
    if ($view == V_MONTH) {
      $label = "Month";

      # Figure out last and next dates for URL links
      @last = Add_Delta_YMD(@$date, 0, -1, 0);
      @next = Add_Delta_YMD(@$date, 0, 1, 0);

      # Different view links
      $vurl = "$url&day=$$date[2]&month=$$date[1]&year=$$date[0]&view=" . V_DAY;
      $view[0] = $cgi->a({href => "javascript:update(4, '$vurl', 5)"},
			 "Day View");

      $vurl = "$url&day=$$date[2]&month=$$date[1]&year=$$date[0]&view=" . V_WEEK;
      $view[1] = $cgi->a({href => "javascript:update(4, '$vurl', 5)"},
			 "Week View");

      $view[2] = "Month View";

      $vurl = "$url&day=$$date[2]&month=$$date[1]&year=$$date[0]&view=" . V_YEAR;
      $view[3] = $cgi->a({href => "javascript:update(4, '$vurl', 5)"},
			 "Year View");

      last;
    }

    # Year View
    if ($view == V_YEAR) {
      $label = "Year";

      # Figure out last and next dates for URL links
      @last = Add_Delta_YMD(@$date, -1, 0, 0);
      @next = Add_Delta_YMD(@$date, 1, 0, 0);

      # Different view links
      $vurl = "$url&day=$$date[2]&month=$$date[1]&year=$$date[0]&view=" . V_DAY;
      $view[0] = $cgi->a({href => "javascript:update(4, '$vurl', 5)"},
			 "Day View");

      $vurl = "$url&day=$$date[2]&month=$$date[1]&year=$$date[0]&view=" . V_WEEK;
      $view[1] = $cgi->a({href => "javascript:update(4, '$vurl', 5)"},
			 "Week View");

      $vurl = "$url&day=$$date[2]&month=$$date[1]&year=$$date[0]&view=" . V_MONTH;
      $view[2] = $cgi->a({href => "javascript:update(4, '$vurl', 5)"},
			 "Month View");

      $view[3] = "Year View";
    }
  }

  # Set up previous and next date URLs
  $purl = "$url&day=$last[2]&month=$last[1]&year=$last[0]&view=$view";
  $nurl = "$url&day=$next[2]&month=$next[1]&year=$next[0]&view=$view";

  # Set up link for today's date
  @today = Today;
  $turl = "$url&day=$today[2]&month=$today[1]&year=$today[0]&view=$view";

  # Set up adding appointment URL
  $aurl = "$url&day=$$date[2]&month=$$date[1]&year=$$date[0]&view=$view&&action=addform";

  &HTMLHeader($cgi, "f4", $cgi->param("key"));

  print $cgi->h1("Commands");

  print $cgi->dl($cgi->dd($cgi->a({href => "javascript:update(4, '$purl', 7)"},
                                  "Previous $label"), $cgi->br,
			  $cgi->a({href => "javascript:update(4, '$nurl', 7)"},
				  "Next $label",),
			  $cgi->br, $cgi->br,
			  $cgi->a({href => "javascript:update(4, '$turl', 7)"},
				  "Go To Today"), $cgi->br,
			  $cgi->a({href => "javascript:enterDate('$url&view=" . V_DAY . "')"},
			  	  "Go To..."),
			  $cgi->br, $cgi->br,
			  $view[0], $cgi->br,
			  $view[1], $cgi->br,
			  $view[2], $cgi->br,
			  $view[3], $cgi->br,
			  $cgi->br,
			  $cgi->a({href => $cgi->url, target => "f2"},
			          "List Calendars"),
			  $cgi->br, $cgi->br, 
			  $cgi->a({href => "javascript:update(4, '$aurl', 1)"},
			          "Add Appointment")));

  print $cgi->hr({size => 4});

  print $cgi->address("$program: v$VERSION by ",
		      $cgi->a({href => 'http://www.csh.rit.edu/~adam/',
			       target => '_top'}, "Adam Stein"));
}

1;

