# Copyright (c) 1999-2003 Xerox Corporation.  All Rights Reserved.
#
# Permission to use, copy, modify  and  distribute  without  charge
# this  software,  documentation, images, etc. is granted, provided
# that this copyright and the author's name is retained.
#    
# A fee may be charged for this program ONLY to recover  costs  for
# distribution  (i.e.  media costs).  No profit can be made on this
# program.
#        
# The author assumes no responsibility for  disasters  (natural  or
# otherwise) as a consequence of use of this software.
#            
# Adam Stein (adam\@scan.mc.xerox.com)

sub ShowCalList {
  my ($cgi) = shift,				# CGI object
  my ($col),					# Column index
  my ($key),					# Key of calendar to display
  my ($me),                             	# URL of this script
  my ($row),					# Row index
  my ($size),					# Num of rows in table
  my ($table),					# Calendar list table
  my ($tlsnb);					# # of calendar entries

  print $cgi->start_html(-title => "$program: Available Calendars");

  print $cgi->h1("Available Calendars:\n");

  $me = $cgi->url;

  $tlsnb = scalar((keys(%calendar)));
  $size = (($tlsnb%NBCOLS==0) ? int($tlsnb/NBCOLS) : int($tlsnb/NBCOLS)+1);
  $row = 0;
  $col = 0;

  foreach (sort(keys(%calendar))) {
    $table[$row][$col]=$_;
    ++$row;
    if ($row == $size) {
      $row=0;
      ++$col;
    }
  }

  print "<TABLE>\n";
  $colnb = 0;
  print "<TR>";

  for ($row = 0;$row<$size;++$row) {
    for ($col = 0;$col<NBCOLS;++$col) {
      $key = $table[$row][$col];
      if (defined($key)) {
        print "<TD>", $cgi->a({href => "$me?key=$key"}, $calendar{$key}[0]), "
</TD>";
        $colnb++;
        if ($colnb == NBCOLS) {
          print "</TR>\n";
          $colnb=0;
        }
      } else {
        print "</TR>\n";
        $colnb=0;
      }
    }
  }

  if ($colnb != 0) {
    print "</TR>\n";
  }

  print "</TABLE>\n";
}

1;

